searchNodes=[{"doc":"Process to gracefully drain Phoenix Socket connections at shutdown.Plug.Cowboy.Drainer is able to handle draining of connections as they complete during a shutdown. Websockets, however, are long-lived connections which may not complete before timeout periods are reached, especially if they have a heartbeat to keep alive. This library handles both in a single dep to keep things simple.In order to gracefully shed Phoenix Sockets, it's necessary to explicitly close these sockets. This is useful in scenarios where a container receives a sigterm during a deployment or scaling down and you want to avoid a thundering herd on your other containers.This module provides a process that during shutdown will initiate shutdown of open Phoenix sockets. When the client receives the disconnect message, it will attempt to reconnect, so this is most effective when used in combination with your load balancer removing the container from the available pool.It should be placed after your Endpoint. On terminate, SocketDrano will spawn non-blocking processes to disconnect monitored socket connections and exit promptly to allow Plug.Cowboy.Drainer to do its thing.Note: This library does not solve the issue of rebalancing of sockets. That's a tougher issue and highly dependent on your load-balancing strategy and infra.Socket connections are discovered via telemetry events and monitored for socket closing.Important: This library currently leverages an undocumented internal function in Phoenix to achieve its magic of closing local sockets. I may attempt to get this functionality explicitly exposed in Phoenix APIs. This could cease working if that internal function were to change, but it should not break.UsageIf you run into issues in your test or development environment, you can set the shutdown_delay to a low value, such as 0 in non-production environments.OptionsThe following options can be given to the child spec::refs - A list of refs to drain. :all is also supported and will drain all cowboy listeners, including those started by means other than Plug.Cowboy. Required:shutdown_delay - How long to wait for connections to drain. This number should match the time provided to Plug.Cowboy.Drainer Defaults to 5000ms.:drain_check_interval - How frequently ranch should check for all connections to have drained.:strategy - Strategy to drain the sockets. The percentage and time should resolve to 100% of connections being drained in a time less than the shutdown time. Defaults to {:percentage, 25, 100}.Examples# In your application def start(_type, _args) do children = [ MyApp.Endpoint, {SocketDrano, refs: [MyApp.Endpoint.HTTP]} ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) endStrategiesOnly a percentage-based strategy is currently supported. Disconnect batches are made according to the percentage size provided. Each batch is processed at the given interval. Within a batch, each individual socket disconnect is processed in its own process with an added jitter of 1-100ms.Telemetry[:socket_drano, :monitor, :start][:socket_drano, :monitor, :stop]","ref":"SocketDrano.html","title":"SocketDrano","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"SocketDrano.html#child_spec/1","title":"SocketDrano.child_spec/1","type":"function"},{"doc":"","ref":"SocketDrano.html#draining?/0","title":"SocketDrano.draining?/0","type":"function"},{"doc":"","ref":"SocketDrano.html#handle_call/2","title":"SocketDrano.handle_call/2","type":"function"},{"doc":"","ref":"SocketDrano.html#handle_event/4","title":"SocketDrano.handle_event/4","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"SocketDrano.html#init/1","title":"SocketDrano.init/1","type":"function"},{"doc":"","ref":"SocketDrano.html#monitor/1","title":"SocketDrano.monitor/1","type":"function"},{"doc":"","ref":"SocketDrano.html#socket_count/0","title":"SocketDrano.socket_count/0","type":"function"},{"doc":"","ref":"SocketDrano.html#start_draining/0","title":"SocketDrano.start_draining/0","type":"function"},{"doc":"","ref":"SocketDrano.html#start_link/1","title":"SocketDrano.start_link/1","type":"function"},{"doc":"Closes connections with keep-alive set on the connection. Do not use this in combination with HTTP2","ref":"SocketDrano.Plug.html","title":"SocketDrano.Plug","type":"module"},{"doc":"","ref":"SocketDrano.Plug.html#call/2","title":"SocketDrano.Plug.call/2","type":"function"},{"doc":"","ref":"SocketDrano.Plug.html#init/1","title":"SocketDrano.Plug.init/1","type":"function"}]